/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.lokalisierung.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class LokalisierungUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale;

    public de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale getLocale(){
      return locale;
    }
    protected final java.lang.String schluessel;

    public java.lang.String getSchluessel(){
      return schluessel;
    }


  public LokalisierungUK(
de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale
, java.lang.String schluessel
  ) {
    super();


      this.locale = locale;
      this.schluessel = schluessel;
      }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((locale == null) ? 0 : locale.hashCode());
                    result = result + ((schluessel == null) ? 0 : schluessel.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            LokalisierungUK other = (LokalisierungUK) obj;

                if (locale == null) {
          if (other.locale != null) {
            return false;
          }
        } else if (!locale.equals(other.locale)) {
          return false;
        }
                if (schluessel == null) {
          if (other.schluessel != null) {
            return false;
          }
        } else if (!schluessel.equals(other.schluessel)) {
          return false;
        }
        
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL, locale));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, schluessel));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "LokalisierungUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"locale="+locale
                            +", "                +"schluessel="+schluessel
                                    ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(locale);
         list.add(schluessel);
     return list;
   }

            public static <E extends Lokalisierung> java.util.Map<LokalisierungUK, E> mappeLokalisierungNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Lokalisierung::getLokalisierungUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Lokalisierung, LokalisierungUK> getLokalisierungToUKFunction() {
                return Lokalisierung::getLokalisierungUK;
                }

}
